#ifndef HAL_TX_H
#define HAL_TX_H

#include <stdbool.h>
#include <stdint.h>
#include "flash.h"

#define LEDS_N (4)
#define ANALOG_AXES_N (4)


typedef struct rgb_t_ rgb_t;

typedef enum analog_axis_t_
{
    ANALOG_AXIS_RIGHT_V = 0,
    ANALOG_AXIS_RIGHT_H,
    ANALOG_AXIS_LEFT_V,
    ANALOG_AXIS_LEFT_H,
}
analog_axis_t;


void hal_tx_init();
uint16_t hal_tx_get_time();
uint16_t hal_tx_sample_axis(analog_axis_t axis);
void hal_tx_rf_send_start();
void hal_tx_rf_send_stop();
void hal_tx_rf_send_bit(bool bit);
void hal_tx_rf_transmit(uint8_t data);
uint32_t hal_tx_read_buttons();
void hal_tx_update_leds(rgb_t *data, uint8_t data_length);
bool hal_tx_read_from_nvm(void *target, uint8_t target_size, uint8_t index);
void hal_tx_write_to_nvm(void *source, uint8_t source_size, uint8_t index);

#endif // HAL_TX_H